#![no_std]
#![no_main]
#![feature(abi_x86_interrupt)]
#![feature(if_let_guard)]
#![feature(allocator_api)]
#![allow(unused)]

extern crate alloc;
mod dev;
mod hard;
mod program;
mod util;

use core::panic::PanicInfo;

use bootloader::{entry_point, BootInfo};
use dev::memory;
use hard::int;

entry_point!(kernel_main);

fn kernel_main(boot_info: &'static BootInfo) -> ! {
	println!("Starting.");
	int::init();
	memory::init(boot_info.physical_memory_offset, &boot_info.memory_map);
	println!("Finished initializations.");
	program::shell::main();
	// program::hello_world::main();
	panic!("Exiting.")
}

#[panic_handler]
fn panic(info: &PanicInfo) -> ! {
	println!("Panicked : {info:?}");
	util::spin();
}
